from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, Array, File, Int, Boolean, Float, Directory

Run_Metasv_Py_V0_1_0 = CommandToolBuilder(tool="run_metasv.py", base_command=["run_metasv.py"], inputs=[ToolInput(tag="in_sample", input_type=String(optional=True), prefix="--sample", doc=InputDocumentation(doc="Sample name (default: None)")), ToolInput(tag="in_pin_del_vcf", input_type=Array(t=String(), optional=True), prefix="--pindel_vcf", doc=InputDocumentation(doc="VCF file or dir for Pindel VCFs (default: [])")), ToolInput(tag="in_pin_del_native", input_type=File(optional=True), prefix="--pindel_native", doc=InputDocumentation(doc="list [File list ...]\nPindel native files (default: [])")), ToolInput(tag="in_break_dancer_vcf", input_type=Array(t=String(), optional=True), prefix="--breakdancer_vcf", doc=InputDocumentation(doc="VCF file or dir for BreakDancer VCFs (default: [])")), ToolInput(tag="in_break_dancer_native", input_type=File(optional=True), prefix="--breakdancer_native", doc=InputDocumentation(doc="list [File list ...]\nBreakDancer native files (default: [])")), ToolInput(tag="in_break_seq_vcf", input_type=Array(t=String(), optional=True), prefix="--breakseq_vcf", doc=InputDocumentation(doc="VCF file or dir for BreakSeq VCFs (default: [])")), ToolInput(tag="in_break_seq_native", input_type=Array(t=String(), optional=True), prefix="--breakseq_native", doc=InputDocumentation(doc="BreakSeq native GFF files (default: [])")), ToolInput(tag="in_cnv_nator_vcf", input_type=Array(t=String(), optional=True), prefix="--cnvnator_vcf", doc=InputDocumentation(doc="VCF file or dir for CNVnator VCFs (default: [])")), ToolInput(tag="in_cnv_nator_native", input_type=File(optional=True), prefix="--cnvnator_native", doc=InputDocumentation(doc="list [File list ...]\nCNVnator native files (default: [])")), ToolInput(tag="in_g_atk_vcf", input_type=Array(t=File(), optional=True), prefix="--gatk_vcf", doc=InputDocumentation(doc="VCF file or dir for gatk VCFs (default: [])")), ToolInput(tag="in_manta_vcf", input_type=Array(t=String(), optional=True), prefix="--manta_vcf", doc=InputDocumentation(doc="VCF file or dir for Manta VCFs (default: [])")), ToolInput(tag="in_lumpy_vcf", input_type=Array(t=String(), optional=True), prefix="--lumpy_vcf", doc=InputDocumentation(doc="VCF file or dir for Lumpy VCFs (default: [])")), ToolInput(tag="in_cnv_kit_vcf", input_type=Array(t=String(), optional=True), prefix="--cnvkit_vcf", doc=InputDocumentation(doc="VCF file or dir for CNVkit VCFs (default: [])")), ToolInput(tag="in_wham_vcf", input_type=Array(t=String(), optional=True), prefix="--wham_vcf", doc=InputDocumentation(doc="VCF file or dir for WHAM VCFs (default: [])")), ToolInput(tag="in_mean_read_length", input_type=Int(optional=True), prefix="--mean_read_length", doc=InputDocumentation(doc="Mean read length (default: 100)")), ToolInput(tag="in_reference", input_type=File(optional=True), prefix="--reference", doc=InputDocumentation(doc="Reference file (default: None)")), ToolInput(tag="in_chromosomes", input_type=Array(t=String(), optional=True), prefix="--chromosomes", doc=InputDocumentation(doc="Chromosome list to process. If unspecified, then all\nchromosomes will be considered. (default: [])")), ToolInput(tag="in_gaps", input_type=File(optional=True), prefix="--gaps", doc=InputDocumentation(doc="Gap bed file (default: None)")), ToolInput(tag="in_filter_gaps", input_type=Boolean(optional=True), prefix="--filter_gaps", doc=InputDocumentation(doc="Filter out gaps (default: False)")), ToolInput(tag="in_keep_standard_contigs", input_type=Boolean(optional=True), prefix="--keep_standard_contigs", doc=InputDocumentation(doc="Keep only the major contigs + MT (default: False)")), ToolInput(tag="in_bams", input_type=Array(t=String(), optional=True), prefix="--bams", doc=InputDocumentation(doc="BAMs (default: [])")), ToolInput(tag="in_i_size_mean", input_type=Int(optional=True), prefix="--isize_mean", doc=InputDocumentation(doc="Insert size mean (default: 350.0)")), ToolInput(tag="in_i_size_sd", input_type=Int(optional=True), prefix="--isize_sd", doc=InputDocumentation(doc="Insert size standard deviation (default: 50.0)")), ToolInput(tag="in_wiggle", input_type=Int(optional=True), prefix="--wiggle", doc=InputDocumentation(doc="Wiggle for interval overlap (default: 100)")), ToolInput(tag="in_ins_wiggle", input_type=Int(optional=True), prefix="--inswiggle", doc=InputDocumentation(doc="Wiggle for insertions, overides wiggle (default: 100)")), ToolInput(tag="in_mins_v_len", input_type=Int(optional=True), prefix="--minsvlen", doc=InputDocumentation(doc="Minimum length acceptable to be an SV (default: 50)")), ToolInput(tag="in_max_sv_len", input_type=Int(optional=True), prefix="--maxsvlen", doc=InputDocumentation(doc="Maximum length SV to report (default: 1000000)")), ToolInput(tag="in_overlap_ratio", input_type=Float(optional=True), prefix="--overlap_ratio", doc=InputDocumentation(doc="Reciprocal overlap ratio (default: 0.5)")), ToolInput(tag="in_min_avg_base_qual", input_type=Int(optional=True), prefix="--min_avg_base_qual", doc=InputDocumentation(doc="Minimum average base quality (default: 20)")), ToolInput(tag="in_min_mapq", input_type=Int(optional=True), prefix="--min_mapq", doc=InputDocumentation(doc="Minimum MAPQ (default: 5)")), ToolInput(tag="in_min_soft_clip", input_type=Int(optional=True), prefix="--min_soft_clip", doc=InputDocumentation(doc="Minimum soft-clip (default: 20)")), ToolInput(tag="in_max_nm", input_type=Int(optional=True), prefix="--max_nm", doc=InputDocumentation(doc="Maximum number of edits (default: 10)")), ToolInput(tag="in_min_matches", input_type=Int(optional=True), prefix="--min_matches", doc=InputDocumentation(doc="Mininum number of matches (default: 50)")), ToolInput(tag="in_min_support_ins", input_type=Int(optional=True), prefix="--min_support_ins", doc=InputDocumentation(doc="Minimum read support for calling insertions using\nsoft-clips (including neighbors) (default: 15)")), ToolInput(tag="in_min_support_frac_ins", input_type=Int(optional=True), prefix="--min_support_frac_ins", doc=InputDocumentation(doc="Minimum fraction of reads supporting insertion using\nsoft-clips (including neighbors) (default: 0.05)")), ToolInput(tag="in_max_ins_intervals", input_type=Int(optional=True), prefix="--max_ins_intervals", doc=InputDocumentation(doc="Maximum number of insertion intervals to generate\n(default: 10000)")), ToolInput(tag="in_mean_read_coverage", input_type=Int(optional=True), prefix="--mean_read_coverage", doc=InputDocumentation(doc="Mean read coverage (default: 50)")), ToolInput(tag="in_min_ins_cov_frac", input_type=Float(optional=True), prefix="--min_ins_cov_frac", doc=InputDocumentation(doc="Minimum read coverage around the insertion breakpoint.\n(default: 0.5)")), ToolInput(tag="in_max_ins_cov_frac", input_type=Int(optional=True), prefix="--max_ins_cov_frac", doc=InputDocumentation(doc="Maximum read coverage around the insertion breakpoint.\n(default: 1.5)")), ToolInput(tag="in_sc_other_scale", input_type=Int(optional=True), prefix="--sc_other_scale", doc=InputDocumentation(doc="Control degree of incorporation of breakpoints from\nother methods. (default: 5)")), ToolInput(tag="in_spades", input_type=File(optional=True), prefix="--spades", doc=InputDocumentation(doc="Path to SPAdes executable (default: None)")), ToolInput(tag="in_spades_options", input_type=String(optional=True), prefix="--spades_options", doc=InputDocumentation(doc="Options for SPAdes (default: )")), ToolInput(tag="in_spades_timeout", input_type=Int(optional=True), prefix="--spades_timeout", doc=InputDocumentation(doc="Maximum time (in seconds) for running SPAdes on an\ninterval (default: 300)")), ToolInput(tag="in_disable_assembly", input_type=Boolean(optional=True), prefix="--disable_assembly", doc=InputDocumentation(doc="Disable assembly (default: False)")), ToolInput(tag="in_svs_to_assemble", input_type=String(optional=True), prefix="--svs_to_assemble", doc=InputDocumentation(doc="[{DUP,INV,DEL,INS} ...]\nSVs to assemble (default: ['INS', 'INV', 'DUP'])")), ToolInput(tag="in_svs_to_soft_clip", input_type=String(optional=True), prefix="--svs_to_softclip", doc=InputDocumentation(doc="[{DUP,INV,DEL,INS} ...]\nSVs to soft-clip (default: ['INS', 'INV', 'DUP'])")), ToolInput(tag="in_extraction_max_read_pairs", input_type=Int(optional=True), prefix="--extraction_max_read_pairs", doc=InputDocumentation(doc="Maximum number of pairs to extract for assembly\n(default: 10000)")), ToolInput(tag="in_spades_max_interval_size", input_type=Int(optional=True), prefix="--spades_max_interval_size", doc=InputDocumentation(doc="Maximum SV length for assembly (default: 50000)")), ToolInput(tag="in_assembly_max_tools", input_type=Int(optional=True), prefix="--assembly_max_tools", doc=InputDocumentation(doc="Skip assembly if more than this many tools support a\ncall (default 1) (default: 1)")), ToolInput(tag="in_assembly_pad", input_type=Int(optional=True), prefix="--assembly_pad", doc=InputDocumentation(doc="Padding base pairs to use for assembling breakpoint\nwith Spades and AGE (default: 500)")), ToolInput(tag="in_stop_spades_on_fail", input_type=Boolean(optional=True), prefix="--stop_spades_on_fail", doc=InputDocumentation(doc="Abort on SPAdes failure (default: False)")), ToolInput(tag="in_age", input_type=File(optional=True), prefix="--age", doc=InputDocumentation(doc="Path to AGE executable (default: None)")), ToolInput(tag="in_age_timeout", input_type=Int(optional=True), prefix="--age_timeout", doc=InputDocumentation(doc="Maximum time (in seconds) for running AGE on an\nassembled contig (default: 300)")), ToolInput(tag="in_min_in_v_sub_align_len", input_type=Int(optional=True), prefix="--min_inv_subalign_len", doc=InputDocumentation(doc="Minimum length of inversion sub-alginment (default:\n50)")), ToolInput(tag="in_min_del_sub_align_len", input_type=Int(optional=True), prefix="--min_del_subalign_len", doc=InputDocumentation(doc="Minimum length of deletion sub-alginment (default: 50)")), ToolInput(tag="in_age_window", input_type=Int(optional=True), prefix="--age_window", doc=InputDocumentation(doc="Window size for AGE to merge nearby breakpoints\n(default: 20)")), ToolInput(tag="in_boost_sc", input_type=Boolean(optional=True), prefix="--boost_sc", doc=InputDocumentation(doc="Use soft-clips for improving breakpoint detection\n(default: False)")), ToolInput(tag="in_gt_window", input_type=Int(optional=True), prefix="--gt_window", doc=InputDocumentation(doc="Window for genotyping (default: 100)")), ToolInput(tag="in_gt_normal_frac", input_type=Int(optional=True), prefix="--gt_normal_frac", doc=InputDocumentation(doc="Min. fraction of reads supporting reference for\ngenotyping (default: 0.05)")), ToolInput(tag="in_svs_to_report", input_type=String(optional=True), prefix="--svs_to_report", doc=InputDocumentation(doc="[{INV,CTX,INS,DEL,ITX,DUP} ...]\nSV types to report (default: set(['INV', 'CTX', 'INS',\n'DEL', 'ITX', 'DUP']))")), ToolInput(tag="in_enable_per_tool_output", input_type=Boolean(optional=True), prefix="--enable_per_tool_output", doc=InputDocumentation(doc="Enable output of merged SVs for individual tools\n(default: False)")), ToolInput(tag="in_workdir", input_type=Directory(optional=True), prefix="--workdir", doc=InputDocumentation(doc="Scratch directory for working (default: work)")), ToolInput(tag="in_num_threads", input_type=Int(optional=True), prefix="--num_threads", doc=InputDocumentation(doc="Number of threads to use (default: 1)")), ToolInput(tag="in_outdir", input_type=Directory(optional=True), prefix="--outdir", doc=InputDocumentation(doc="Output directory (default: None)"))], outputs=[ToolOutput(tag="out_outdir", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_outdir", type_hint=File()), doc=OutputDocumentation(doc="Output directory (default: None)"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Run_Metasv_Py_V0_1_0().translate("wdl", allow_empty_container=True)

